# mypy-boto3-iot1click-projects

[![PyPI - mypy-boto3-iot1click-projects](https://img.shields.io/pypi/v/mypy-boto3-iot1click-projects.svg?color=blue)](https://pypi.org/project/mypy-boto3-iot1click-projects)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-iot1click-projects.svg?color=blue)](https://pypi.org/project/mypy-boto3-iot1click-projects)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.IoT1ClickProjects 1.14.3](https://boto3.amazonaws.com/v1/documentation/api/1.14.3/reference/services/iot1click-projects.html#IoT1ClickProjects) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `IoT1ClickProjects` service.

```bash
python -m pip install boto3-stubs[iot1click-projects]
```

## How to use

### Client annotations

`IoT1ClickProjectsClient` provides annotations for `boto3.client("iot1click-projects")`.

```python
import boto3

from mypy_boto3_iot1click_projects import IoT1ClickProjectsClient
from mypy_boto3_iot1click_projects.paginator import ListPlacementsPaginator, ListProjectsPaginator
from mypy_boto3_iot1click_projects.type_defs import DeviceTemplateTypeDef, ...

client: IoT1ClickProjectsClient = boto3.client("iot1click-projects")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: IoT1ClickProjectsClient = session.client("iot1click-projects")
```

### Paginators annotations

`mypy_boto3_iot1click_projects.paginator` module contains type annotations for all paginators.

```python

client: IoT1ClickProjectsClient = boto3.client("iot1click-projects")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_placements_paginator: ListPlacementsPaginator = client.get_paginator("list_placements")
list_projects_paginator: ListProjectsPaginator = client.get_paginator("list_projects")
```







### Typed dictionations

`mypy_boto3_iot1click_projects.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> DeviceTemplateTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_iot1click_projects` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("iot1click-projects")

session_client = boto3.Session().client("iot1click-projects")
```
